#!/usr/bin/perl

$SYNOP="fpm2keepass
Homepage: http://www.henning-mersch.de/projects
Author: Henning Mersch <mail\@henning-mersch.de>
License: GPLv2

Convert a FPM (http://fpm.sourceforge.net/) exported asc file 
to a csv file for Keepass (http://keepass.info/) import.
%> fpm2keepass INFILE > OUTFILE

";

if(!$ARGV[0]) {
  print STDERR $SYNOP;
  exit;
}

#print header
print '"Account","Login Name","Password","Web Site","Comments"
';
#define output
#$OUTPUT = 'user=##title## ##user## passwd=##passwd## url=##url## note=##note##\n';
$OUTPUT = '"##title##","##user##","##passwd##","##url##","##note##"
';

open(FH, "+<$ARGV[0]") or die "Opening: $!";
my @lines = <FH>;
for (my $i=0;$i<@lines;$i++) {
  if($lines[$i] =~ /^\n/ && $lines[$i+1] =~ /^title=/ && defined %item) {
    print STDERR "\nempty line --> DUMP !\n";
	$currentOut = $OUTPUT;
	$currentOut =~ s/##title##/$item{title}/;
	$currentOut =~ s/##user##/$item{user}/;
	$currentOut =~ s/##passwd##/$item{passwd}/;
	$currentOut =~ s/##url##/$item{url}/;
	$currentOut =~ s/##note##/$item{notes}/;
	print $currentOut;
	undef($lastkey);
	undef(%item);
  } elsif ($lines[$i] =~ /^(title|user|passwd|url|notes)=(.*)\n/){
	$item{$1} = $2;
    print STDERR "\ngot $1 --> $2";
	$lastkey = $1
  } elsif(defined $lastkey) {
    chomp($lines[$i]);
	$item{$lastkey} .= "\n".$lines[$i];
	print STDERR "\nappending to $lastkey: '$lines[$i]'";
  } else {
	print STDERR "FATAL ERROR on parsing: $lines[$i] - Goodbye";
	exit 1;
  }

}

print STDERR "\nall read --> DUMP !\n";
$currentOut = $OUTPUT;
$currentOut =~ s/##title##/$item{title}/;
$currentOut =~ s/##user##/$item{user}/;
$currentOut =~ s/##passwd##/$item{passwd}/;
$currentOut =~ s/##url##/$item{url}/;
$currentOut =~ s/##note##/$item{notes}/;
print $currentOut;

exit 0;
